import 'core-js/features/promise';
import { DocumentReference, CollectionReference, DocumentSnapshot, Query, QuerySnapshot } from 'firebase/firestore';
import 'core-js/features/promise';
import 'firebase/compat/firestore';
import { Firestore } from '@firebase/firestore';
import { firestore as firebaseAdminFirestore } from 'firebase-admin';
import AdminDocumentReference = firebaseAdminFirestore.DocumentReference;
import AdminDocumentSnapshot = firebaseAdminFirestore.DocumentSnapshot;
import AdminFirestore = firebaseAdminFirestore.Firestore;
export interface CachedDocumentSnapshotPromise extends Promise<DocumentSnapshot | AdminDocumentSnapshot> {
    time: number;
}
export interface IncludeConfig {
    [key: string]: Function | Object;
}
export interface JoinRef {
    _type: string;
    path: string;
}
export interface JoinDate {
    _type: string;
    value: string;
}
export declare class SerializedDocumentPromise<T extends SerializedInterface<T>> extends Promise<SerializedDocument<T>> {
    ready: () => Promise<SerializedDocument<T>>;
    constructor(fn: any);
}
export declare class SerializedDocumentArrayPromise<T extends SerializedInterface<T>> extends Promise<SerializedDocumentArray<T>> {
    ready: () => Promise<SerializedDocumentArray<T>>;
    constructor(fn: any);
}
export declare class SerializedDocumentArray<T extends SerializedInterface<T>> extends Array<SerializedDocument<T>> {
    constructor(querySnapshot: QuerySnapshot, includesConfig?: IncludeConfig | 'ALL');
    static fromDocumentReferenceArray: <T_1 extends SerializedInterface<T_1>>(documentReferenceArray: [DocumentReference | AdminDocumentReference], includesConfig?: IncludeConfig | 'ALL') => SerializedDocumentArrayPromise<T_1>;
    static fromQuery: <T_1 extends SerializedInterface<T_1>>(collectionReferenceOrQuery: CollectionReference | Query, includesConfig?: IncludeConfig | 'ALL') => SerializedDocumentArrayPromise<T_1>;
    static fromJSON: (obj: string, firestore: Firestore) => SerializedDocumentArray<any>;
    allPromises(): Promise<any[][]>;
    allPromisesRecursive(): Promise<unknown[]>;
    ready(): Promise<SerializedDocumentArray<T>>;
    JSONStringify(): string;
}
interface SerializedInterface<T> extends Partial<SerializedDocument<T>> {
}
export declare class SerializedDocument<T extends SerializedInterface<T>> {
    data: T['data'];
    ref: DocumentReference | AdminDocumentReference;
    modularRef: DocumentReference;
    compactRef: AdminDocumentReference;
    included: T['included'];
    promises: Object;
    _promisesArray: Promise<any>[];
    _includedArray: SerializedDocument<T>[];
    snapshot: DocumentSnapshot | AdminDocumentSnapshot;
    constructor(documentSnapshot: DocumentSnapshot | AdminDocumentSnapshot, includeConfig?: IncludeConfig | 'ALL');
    static createLocal: <T_1 extends SerializedInterface<T_1>>(ref: DocumentReference | AdminDocumentReference, data?: any, includeConfig?: IncludeConfig | 'ALL') => SerializedDocument<T_1>;
    static fromDocumentReference: <T_1 extends SerializedInterface<T_1>>(ref: DocumentReference | AdminDocumentReference, includeConfig?: IncludeConfig | 'ALL') => SerializedDocumentPromise<T_1>;
    static fromJSON: (obj: string, firestore: Firestore) => SerializedDocument<any>;
    static toJSON: (obj: any) => string;
    processIncludes: (includeConfig: IncludeConfig | 'ALL') => void;
    includeReferenceArray: (path: string, documentReferenceArray: DocumentReference[] | AdminDocumentReference[], includeConfig?: {}) => void;
    includeDocumentReference: (path: string, documentReference: DocumentReference | AdminDocumentReference, includeConfig?: {}) => void;
    includeCollectionReferenceOrQuery: (path: string, collectionReferenceOrQuery: CollectionReference | Query, includeConfig?: {}) => void;
    findReferences: (data: {
        [key: string]: any;
    }, _pathSegments: Array<string>) => void;
    allPromisesRecursive: () => Promise<unknown>;
    ready: () => Promise<SerializedDocument<T>>;
    JSONStringify: () => string;
}
export declare function setCacheTimeout(milliseconds: number): void;
export declare function setFirebaseType(type: 'modular' | 'compat' | 'admin'): void;
export declare function setSerializedDocumentTransformer(transformerFunction: Function): void;
export declare function getCachedDocumentSnapshotPromise(documentReference: DocumentReference | AdminDocumentReference): CachedDocumentSnapshotPromise;
export declare function toJSON(data: {
    [key: string]: any;
}): string;
export declare function processParsedJoinJSON(data: any, firestore: Firestore | AdminFirestore): any;
export declare function fromJSON(data: string, firestore: Firestore | AdminFirestore): any;
export {};
